<template>
  <section class="pb-20">
    <!-- <div class="pt-6 pb-4 wrapper border-b-[1.5px] borderBox dark:border-[#1a283a] ">
      <h3 class="sectionTitle">
        {{$t('codebase')}}
      </h3>
    </div> -->






    <!-- =================================================================================================================================================
                                                                    HEADER_SECTION START
    ================================================================================================================================================= -->
    <div v-if="categoriesList.length" class="flex items-center justify-between border-b-[1.5px] borderBox dark:border-[#1a283a]  wrapper h-[70px]">
      <ul class="basicTab">

        <li
          v-for="(item, index) in windowWidth > 1440 ? categoriesList : categoriesList.slice(0, 6)" :key="index"
          @click="() => { 
              categoriesPopupActive = false
              changeTable(item.id) 
            }"
          :class="item.id == $route.query.product_category_id ? 'active' : ''"
          class="main-color-black font-medium duration-100"
        >
          {{ item[`name_${locale}`] }}
        </li>

        <li 
          v-if="windowWidth < 1441"
          @click="categoriesPopupActive = !categoriesPopupActive"
          class="blue-text font-medium duration-100 relative">
          {{ $t('others') }}
          <functions-popup
            v-if="categoriesPopupActive"
            additonalClasses='top-[120px] translate-y-auto left-1/2 -translate-x-1/2 py-4 px-4 w-auto'
          >
            <template v-slot:FunctionsPopupContent>
                <div class="flex flex-col space-y-3">
                  <div 
                  v-for="(item, index) in categoriesList.slice(6)" 
                  :key="index"
                  :class="item.id == $route.query.product_category_id ? 'text-[#5fc7d1] dark:text-white' : 'text-[#696F7A]'"
                  @click="changeTable(item.id)"
                  class="whitespace-nowrap p-0">
                  {{ item[`name_${locale}`] }}
                </div>
                </div>
            </template>
          </functions-popup>
        </li>

      </ul>

      <div>
        <button
         @click="toggleModal()"
         class="mainBackgroundColor hover:scale-105 duration-100 text-white basicBtn"
          >
          <PlusIcon stroke="stroke-current mr-2" />
          {{$t('add')}}
        </button>
      </div>
    </div>
    <Skeleton v-else classes="w-full h-[70px]" />
    <!-- =================================================================================================================================================
                                                                    HEADER_SECTION END
    ================================================================================================================================================= -->













    <!-- =================================================================================================================================================
                                                                    TABLE_SECTION START
    ================================================================================================================================================= -->
    <div class="a-table">
      <div class="table-1">
        <div class="wrapper border-b-[1.5px] borderBox dark:border-[#1a283a]  h-[500px]">
          <div
            class="uk-grid-medium uk-grid-match uk-child-width-expand h-full"
            uk-grid
          >
            <div class="h-full">
              <div class="a-card h-full">
                <div class="uk-grid-collapse uk-child-width-1-2 h-full" uk-grid>
                  <div>
                    <div class="border-r-[1.5px] borderBox dark:border-[#1a283a]  pr-10 h-full">
                      
                      <div class="a-card-header">
                        <ul
                          class="uk-grid-collapse a-table-list pb-5"
                          uk-grid
                        >
                          <li class="uk-width-1-4">
                            <h3 class="a-table-title">{{$t('code')}}</h3>
                          </li>
                          <li class="uk-width-expand">
                            <h3 class="a-table-title">{{$t('created_date')}}</h3>
                          </li>
                          <li class="uk-width-1-4">
                            <h3 class="a-table-title">{{$t('name')}}</h3>
                          </li>
                          <li class="w-[120px]">
                            <h3 class="a-table-title flex justify-center">{{$t('actions')}}</h3>
                          </li>
                        </ul>
                      </div>

                      <div v-if="!isLoading" class="a-card-body">
                        <ul
                          v-for="item in productsListLeft"
                          class="uk-grid-collapse a-table-list border-t-[1.5px] borderBox dark:border-[#1a283a] "
                          uk-grid
                          :key="item.id"
                        >
                          <li class="uk-width-1-4">
                            <h3 class="a-table-text blue-text">{{ item.code }}</h3>
                          </li>
                          <li class="uk-width-expand">
                            <h3 class="a-table-text" :class="$isDark ? 'dark' : ''">{{ $dayjs(item.created_at).format('DD-MM-YYYY') }}</h3>
                          </li>
                          <li class="uk-width-1-4">
                            <h3 class="a-table-text" :class="$isDark ? 'dark' : ''">{{ item[`name_${locale}`] }}</h3>
                          </li>
                          <li class="w-[120px]">
                            <div class="relative">
                              <v-confirm v-if="confirmDeleteProduct == item.id" classes="right-[100px] left-auto top-[15px] -translate-y-1/2" :question="$t('are_realy_want_to_delete_this')" @cancel="() => {confirmDeleteProduct = null}" @confirm="deleteProduct(item.id)" />
                              <div
                                @click="togglePopup(item.id)"
                                class="cursor-pointer flex justify-center w-full" :class="$isDark ? 'text-[#66b2ff]' : 'text-[#5FC7D1]'"
                              >
                                <FunctionsIcon
                                  stroke="stroke-current"
                                  width="30"
                                  height="30"
                                />
                              </div>

                              <functions-popup
                                v-if="popUpActive == item.id"
                                additonalClasses="z-[11]"
                              >
                                <template v-slot:FunctionsPopupContent>
                                  <div class="flex flex-col space-y-3">
                                    <button
                                      @click="editProduct(item)"
                                      class="functionsText mainColorText"
                                    >
                                      {{$t('edit')}}
                                    </button>
                                    <button
                                      @click="() => {
                                        confirmDeleteProduct = item.id,
                                        popUpActive = null
                                      }"
                                      class="text-[#E54D43] functionsText"
                                    >
                                      {{$t('delete')}}
                                    </button>
                                  </div>
                                </template>
                              </functions-popup>
                            </div>
                          </li>
                        </ul>
                      </div>

                      <Skeleton v-if="isLoading" classes="w-full h-[440px]" />
                      <null-data v-else-if="isErrorLeft || !productsListLeft.length" width='w-[120px]' classes='h-full h-[440px]' />
                    </div>
                  </div>

                  <!-- =========================================================================================================================
                  ========================================================================================================================= -->

                  <div>
                    <div class="pl-10">
                      <div class="a-card-header">
                        <ul
                          class="uk-grid-collapse a-table-list pb-5"
                          uk-grid
                        >
                          <li class="uk-width-1-4">
                            <h3 class="a-table-title">{{$t('code')}}</h3>
                          </li>
                          <li class="uk-width-expand">
                            <h3 class="a-table-title">{{$t('created_date')}}</h3>
                          </li>
                          <li class="uk-width-1-4">
                            <h3 class="a-table-title">{{$t('name')}}</h3>
                          </li>
                          <li class="w-[120px]">
                            <h3 class="a-table-title flex justify-center">{{$t('actions')}}</h3>
                          </li>
                        </ul>
                      </div>

                      <div v-if="!isLoading" class="a-card-body">
                        <ul
                          v-for="item in productsListRight"
                          class="uk-grid-collapse a-table-list border-t-[1.5px] borderBox dark:border-[#1a283a] "
                          uk-grid
                          :key="item.id"
                        >
                          <li class="uk-width-1-4">
                            <h3 class="a-table-text blue-text">{{ item.code }}</h3>
                          </li>
                          <li class="uk-width-expand">
                            <h3 class="a-table-text" :class="$isDark ? 'dark' : ''">{{ $dayjs(item.created_at).format('DD-MM-YYYY') }}</h3>
                          </li>
                          <li class="uk-width-1-4">
                            <h3 class="a-table-text" :class="$isDark ? 'dark' : ''">{{ item[`name_${locale}`] }}</h3>
                          </li>
                          <li class="w-[120px]">
                            <div class="relative">
                              <v-confirm v-if="confirmDeleteProduct == item.id" classes="right-[100px] left-auto top-[15px] -translate-y-1/2" :question="$t('are_realy_want_to_delete_this')" @cancel="() => {confirmDeleteProduct = null}" @confirm="deleteProduct(item.id)" />
                              <div
                                @click="togglePopup(item.id)"
                                class="cursor-pointer flex justify-center w-full" :class="$isDark ? 'text-[#66b2ff]' : 'text-[#5FC7D1]'"
                              >
                                <FunctionsIcon
                                  stroke="stroke-current"
                                  width="30"
                                  height="30"
                                />
                              </div>

                              <functions-popup
                                v-if="popUpActive == item.id"
                                additonalClasses="z-[11]"
                              >
                                <template v-slot:FunctionsPopupContent>
                                  <div class="flex flex-col space-y-3">
                                    <button
                                      @click="editProduct(item)"
                                      class="functionsText mainColorText"
                                    >
                                      {{$t('edit')}}
                                    </button>
                                    <button
                                      @click="() => {
                                        confirmDeleteProduct = item.id,
                                        popUpActive = null
                                      }"
                                      class="text-[#E54D43] functionsText"
                                    >
                                      {{$t('delete')}}
                                    </button>
                                  </div>
                                </template>
                              </functions-popup>
                            </div>
                          </li>
                        </ul>
                      </div>

                      <Skeleton v-if="isLoading" classes="w-full h-[440px]" />
                      <null-data v-else-if="isErrorRight || !productsListRight.length" width='w-[120px]' classes='h-full h-[440px]' />
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>

        </div>


        <div class="flex justify-end mt-10 wrapper" v-if="!isLoading && !isError">
          <v-pagination
            v-model="params.pagination.page"
            :pages="params.pagination.total"
            :range-size="1"
            @update:modelValue="updatePage"
            :hideFirstButton="true"
            hideLastButton="true"
          />
        </div>

      </div>
    </div>
    <!-- =================================================================================================================================================
                                                                    TABLE_SECTION END
    ================================================================================================================================================= -->











    <!-- =================================================================================================================================================
                                                                      MODAL_SECTION START
    ================================================================================================================================================= -->
    <Modal @submitModal="createOrUpdateProduct" :isModalActive="isModalActive" @close="toggleModal" width='w-[430px]' :buttonText="$t(textBtn)" :outsideClose="false">
      <template v-slot:modalHeader>
        <h3 class="text-lg font-medium text-center main-color-black dark:text-white">
          {{textBtn == 'edit' ? $t('editing') : $t('new_product_code')}}
        </h3>
      </template>

      <template v-slot:modalBody>
        <div class="mt-4 space-y-5">

          <div class="relative">
            <Datepicker :inputClassName="`datepicker ${$isDark ? 'dark' : 'light'}`" menuClassName="dp-custom-menu" calendarClassName="dp-custom-calendar" 
            v-model="createdDate" :placeholder="$t('created_date')" 
            readonly="textBtn == 'edit' ? true : false"
            :locale="locale == 'ru' ? 'ru' : 'uz'"
            :cancelText="locale == 'ru' ? 'Отмена' : 'Bekor qilish'"
            :selectText="locale == 'ru' ? 'ОК' : 'Tanlash'"></Datepicker>
          </div>


          <div class="relative">
            <img
              class="absolute left-4 top-1/2 -translate-y-1/2"
              src="@/assets/icons/baseIcons/product.svg"
              alt="icon"
            />
            <vue-select :options="categoriesList" @select="(option) => formProduct.product_category_id = option.id" classes="main-color-black pl-12"
            :clearSelection="clearSelection" :selectedElement="formProduct.category ? formProduct.category[`name_${locale}`] : ''" 
            :readonly="textBtn == 'edit' ? true : false" :placeholder="$t('category')" />

            <p class="absolute -bottom-5 whitespace-nowrap danger-text text-sm z-[2]" v-for="error in validate.product_category_id.$errors" 
            :key="error.$uid">{{ $t(error.$message) }}</p>
          </div>

          <div class="form-input-anim relative" :class="$isDark ? 'dark' : ''">
            <img
              class="absolute left-4 top-1/2 -translate-y-1/2"
              src="@/assets/icons/baseIcons/edit.svg"
              alt="icon"
            />
            <input
              v-model="formProduct.name_ru"
              type="text"
              name="text"
              autocomplete="off"
              required
              class="w-full py-[14px] px-[24px] pl-12 focus:outline-none main-color-black border-[1.5px] borderBox dark:border-[#1a283a]  rounded-[12px] text-lg"
              :class="$isDark ? 'dark' : 'light'"
            />
            <label for="text" class="label-name">
              <span class="content-name">{{$t('name')}}</span>
            </label>
            <p class="absolute -bottom-5 whitespace-nowrap danger-text text-sm z-[2]" v-for="error in validate.name_ru.$errors" :key="error.$uid">{{ $t(error.$message) }}</p>
          </div>

          <div class="form-input-anim relative" :class="$isDark ? 'dark' : ''">
            <img
              class="absolute left-4 top-1/2 -translate-y-1/2"
              src="@/assets/icons/allMoney.svg"
              alt="icon"
            />
            <input
              v-model="formProduct.code"
              type="text"
              name="text"
              autocomplete="off"
              required
              class="w-full py-[14px] px-[24px] pl-12 focus:outline-none main-color-black border-[1.5px] borderBox dark:border-[#1a283a]  rounded-[12px] text-lg" :class="$isDark ? 'dark' : 'light'"
            />
            <label for="text" class="label-name">
              <span class="content-name">{{$t('code')}}</span>
            </label>
            <p class="absolute -bottom-5 whitespace-nowrap danger-text text-sm z-[2]" v-for="error in validate.code.$errors" :key="error.$uid">{{ $t(error.$message) }}</p>
          </div>
        </div>
      </template>
    </Modal>
    <!-- =================================================================================================================================================
                                                                      MODAL_SECTION END
    ================================================================================================================================================= -->










    <!-- =================================================================================================================================================
                                                                      FILTER_SECTION START
    ================================================================================================================================================= -->
    <Filter @cancelFilter="clearTheFilter()" buttonClass="mt-24" wrapperClass='top-[180px]' :cancelButtonText="$t('clean')">
      <template v-slot:filterBody>
        <div class="w-[300px] grid grid-cols-1 gap-3">
          <div class="relative">
            <img
              class="absolute left-4 top-1/2 -translate-y-1/2"
              src="@/assets/icons/baseIcons/user-square.svg"
              alt="icon"
            />
            <input
              v-model="params.search_name"
              v-debounce:500="handleFilterSearchName"
              type="text"
              name="text"
              autocomplete="off"
              required
              :placeholder="$t('search_by_name')"
              class="w-full py-[14px] px-[24px] pl-12 focus:outline-none main-color-black border-[1.5px] borderBox dark:border-[#1a283a]  rounded-[12px] text-lg"
            />
          </div>
          <div class="relative">
            <img
              class="absolute left-4 top-1/2 -translate-y-1/2"
              src="@/assets/icons/baseIcons/code.svg"
              alt="icon"
            />
            <input
              v-model="params.search_code"
              v-debounce:500="handleFilterSearchCode"
              type="text"
              name="text"
              autocomplete="off"
              required
              :placeholder="$t('search_by_code')"
              class="w-full py-[14px] px-[24px] pl-12 focus:outline-none blue-text border-[1.5px] borderBox dark:border-[#1a283a]  rounded-[12px] text-lg"
            />
          </div>
        </div>
      </template>
    </Filter>
    <!-- =================================================================================================================================================
                                                                      FILTER_SECTION END
    ================================================================================================================================================= -->






  </section>
</template>

<script>



// ========================= IMPORTS_SECTION START =========================
import { onMounted, ref, computed } from "vue";
import { useRouter, useRoute } from 'vue-router'
import { useI18n } from 'vue-i18n';
import { useToast } from 'vue-toastification'
import { codebaseStore } from '@/store/modules/pages/Codebase.js'

import Modal from '@/components/base/Modal.vue'
import PlusIcon from "@/assets/iconsVue/PlusIcon.vue";
import SmallArrowRight from "@/assets/iconsVue/SmallArrowRight.vue";
import FunctionsIcon from "@/assets/iconsVue/FunctionsIcon.vue";
import dayjs from 'dayjs';
import useVuelidate from '@vuelidate/core'
import { required, helpers } from '@vuelidate/validators'
// ========================= IMPORTS_SECTION START =========================



export default {
  components: {



    // ========================= COMPONENTS_DEFINE_SECTION START =========================
    Modal,
    SmallArrowRight,
    PlusIcon,
    FunctionsIcon,
    // ========================= COMPONENTS_DEFINE_SECTION END =========================



  },
  setup() {






    // ========================= PRIMARY_DATA_SECTION START =========================
    const { t, locale } = useI18n()
    const codebaseStorage = codebaseStore()
    const router = useRouter()
    const route = useRoute()
    const toast = useToast()
    const productsListLeft = ref([])
    const productsListRight = ref([])
    const categoriesList = ref([])
    const createdDate = ref('')
    const currantTable = ref()
    const popUpActive = ref(null)
    const textBtn = ref('confirm')
    const isModalActive = ref(false)
    const confirmDeleteProduct = ref(false)
    const isLoading = ref(false)
    const isError = ref(false)
    const isErrorLeft = ref(false)
    const isErrorRight = ref(false)
    const categoriesPopupActive = ref(false)
    const windowWidth = window.innerWidth
    const params = ref({
      search_name: '',
      search_code: '',
      pagination: {
        page: 1,
        total: 1,
        limit: 10
      }
    });


    const formProduct = ref({
      code: '',
      product_category_id: null,
      name_ru: '',
      created_at: '',
      category: {name_ru: '', name_uz: ''}
    })
    let clearSelection = ref(false)
    // ========================= PRIMARY_DATA_SECTION END =========================










    // ========================= VALIDATION_SECTION START =========================
    const rules = computed(() => {
      return {
        name_ru: {
          required: helpers.withMessage('Пожалуйста, введите имя', required)
        },
        code: { 
          required: helpers.withMessage('Пожалуйста, введите код', required)
        },
        product_category_id: { 
          required: helpers.withMessage('Пожалуйста, выберите категорию', required)
        }
      }
    })
    const validate = useVuelidate(rules, formProduct)
    // ========================= VALIDATION_SECTION END =========================










    // ========================= CHANGE_TABLE_SECTION START =========================
    const changeTable = (e) => {
      router.push(`/codebase?product_category_id=${e}`)
      params.value.pagination.page = 1
      currantTable.value = e
      getProducts(e)
    };
    // ========================= CHANGE_TABLE_SECTION END =========================








    // ========================= POPUP_AND_MODAL_SECTION START =========================
    const togglePopup = (id) => {
      if (popUpActive.value === id) {
        popUpActive.value = null
      } else {
        popUpActive.value = id
      }
    };

    const toggleModal = (product_category_id) => {
      isModalActive.value = !isModalActive.value
      router.replace(`/codebase?product_category_id=${product_category_id ? product_category_id : currantTable.value}`)
      popUpActive.value = null

      if (!isModalActive.value) {
        formProduct.value = {
          code: '',
          product_category_id: null,
          name_ru: '',
        }
        createdDate.value = ''
      }
      if (!route.query.product) {
        textBtn.value = 'сonfirm'
        createdDate.value = new Date
        formProduct.value.product_category_id = currantTable.value
        let a = categoriesList.value.find((e) => e.id == currantTable.value)
        formProduct.value.category = a
      }
    }
    // ========================= POPUP_AND_MODAL_SECTION END =========================








    // ========================= EDIT_AND_DELETE_SECTION START =========================
    const editProduct = async (data) => {
      formProduct.value = data
      createdDate.value = data.created_at
      textBtn.value = 'edit'
      isModalActive.value = !isModalActive.value
      popUpActive.value = null
      router.replace(`/codebase?product_category_id=${currantTable.value}&product=${data.id}`)

      formProduct.value.product_category_id = currantTable.value
      let a = categoriesList.value.find((e) => e.id == currantTable.value)
      formProduct.value.category= a
    }

    const deleteProduct = async (id) => {
      confirmDeleteProduct.value = null
      await codebaseStorage.DELETE_PRODUCT(id).then((response) => {
          if (response.data) {
            codebaseStorage.updateCodebase = true
            toast.success(t('successfully-deleted'))
            getProducts(route.query.product_category_id)
          }
      })
    }
    // ========================= EDIT_AND_DELETE_SECTION END =========================










    // ========================= CREATE_OR_UPDATE_SECTION START =========================
    const createOrUpdateProduct = async () => {
      clearSelection.value = true

      const result = await validate.value.$validate()
      if (result) {
        if (route.query.product) {
          const data = {
            code: formProduct.value.code,
            product_category_id: formProduct.value.product_category_id,
            name_ru: formProduct.value.name_ru,
            created_at: formProduct.value.created_at ? dayjs(formProduct.value.created_at).format('YYYY-MM-DD HH:mm:ss') : dayjs().format('YYYY-MM-DD HH:mm:ss')
          }
          await codebaseStorage.EDIT_PRODUCT({data: data, id: route.query.product}).then(async (response) => {
            if (response && response.status && response.status == '200') {
              validate.value.$reset()
              codebaseStorage.updateCodebase = true
              toast.success(t('successfully-edited'))
              await getProducts(route.query.product_category_id)
              await toggleModal(route.query.product_category_id)
            }else{
              // toast.error(t('error-occured'))
            }

          })
        } else {
          const data = {
            code: formProduct.value.code,
            product_category_id: formProduct.value.product_category_id,
            name_ru: formProduct.value.name_ru,
            created_at: createdDate.value ? dayjs(createdDate.value).format('YYYY-MM-DD HH:mm:ss') : dayjs().format('YYYY-MM-DD HH:mm:ss')
          }
          await codebaseStorage.ADD_PRODUCT(data).then(async (response) => {
            if(response && response.status && response.status == '200'){
              validate.value.$reset()
              codebaseStorage.updateCodebase = true
              toast.success(t('successfully-added'))
              await getProducts(route.query.product_category_id)
              await toggleModal(route.query.product_category_id)
            }else{
              // toast.error(t('error-occured'))
            }
          })
        }
      }

      clearSelection.value = false  
    }
    // ========================= CREATE_OR_UPDATE_SECTION END =========================






    // ========================= GET_SECTION START =========================
    const getProductCategories = async () => {
      await codebaseStorage.GET_PRODUCT_CATEGORIES().then(response => {
        categoriesList.value = response.data.data.sort((a, b) => a > b ? 1 : -1).map(item => {
          return {
            title: item[`name_${locale.value}`],
            ...item
          }
        })
        if (route.query.product_category_id) {
          router.push(route.fullPath)
          currantTable.value = route.query.product_category_id
          setTimeout(() => {
            getProducts(route.query.product_category_id)
          }, 0)
        } else {
          router.push(`/codebase?product_category_id=${response.data.data[0].id}`)
          currantTable.value = response.data.data[0].id
          setTimeout(() => {
            getProducts(response.data.data[0].id)
          }, 0)
        }
      })
    }


    const getProducts = async (product_category_id) => {
      isLoading.value = true
      const data = {
        product_category_id: product_category_id,
        page: params.value.pagination.page,
        per_page: params.value.pagination.limit,
        code: route.query.search_code ? route.query.search_code : '',
        name_ru: route.query.search_name ? route.query.search_name : ''
      }
      await codebaseStorage.GET_PRODUCTS(data).then(response => {
        if (response.status == 200) {
          params.value.pagination.total = response.data.data.total > 9 ? Math.ceil(response.data.data.total / 10) : 1
          if (response.data.data.data.length && response.data.data.data.length < 2) {
            productsListLeft.value = response.data.data.data
            productsListRight.value = []
          } else if (response.data.data.data.length && response.data.data.data.length > 1) {
            productsListLeft.value = response.data.data.data.slice(0, Math.ceil(response.data.data.data.length / 2))
            productsListRight.value = response.data.data.data.slice(Math.ceil(response.data.data.data.length / 2))
          } else {
            productsListLeft.value = []
            productsListRight.value = []
          }
          if (route.query.product) {
            // editProduct(response.data.data.data.filter(item => item.id == route.query.product)[0])
          }
        }
      })
      .catch(() => {
        isErrorLeft.value = true
        isErrorRight.value = true
      })
      .finally(() => {
        isLoading.value = false
      })
    }
    // ========================= GET_SECTION END =========================






    // ========================= OTHERS_SECTION START =========================
    async function updatePage(value) {
      params.value.pagination.page = value
      await getProducts(route.query.product_category_id)
    }

    function handleFilterSearchName(value) {
      router.push(`/codebase?product_category_id=${currantTable.value}&search_name=${value}&search_code=${params.value.search_code}`)
      setTimeout(() => {
        getProducts(route.query.product_category_id)
      }, 500);
    }

    function handleFilterSearchCode (value) {
      router.push(`/codebase?product_category_id=${currantTable.value}&search_name=${params.value.search_name}&search_code=${value}`)
      setTimeout(() => {
        getProducts(route.query.product_category_id)
      }, 500);
    }

    const clearTheFilter = () => {
      params.value.search_name = ''
      params.value.search_code = ''
      router.push(`/codebase?product_category_id=${currantTable.value}`)
      setTimeout(() => {
        getProducts(route.query.product_category_id)
      }, [0])
    }
    // ========================= OTHERS_SECTION END =========================






    // ========================= MOUNTED_SECTION START =========================
    onMounted( async () => {
      await getProductCategories()
    })
    // ========================= MOUNTED_SECTION END =========================




    return {
      formProduct,
      categoriesList,
      isModalActive,
      createdDate,
      productsListLeft,
      productsListRight,
      locale,
      popUpActive,
      textBtn,
      confirmDeleteProduct,
      isLoading,
      isError,
      isErrorLeft,
      isErrorRight,
      validate,
      currantTable,
      params,
      categoriesPopupActive,
      windowWidth,

      changeTable,
      createOrUpdateProduct,
      editProduct,
      deleteProduct,
      toggleModal,
      togglePopup,
      updatePage,
      handleFilterSearchCode,
      handleFilterSearchName,
      clearTheFilter,

      clearSelection,
    }
  },
};
</script>

<style></style>
